import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface RegionalHostnameConfig extends cdktf.TerraformMetaArguments {
    /**
    * The hostname to regionalize.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.6.0/docs/resources/regional_hostname#hostname RegionalHostname#hostname}
    */
    readonly hostname: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.6.0/docs/resources/regional_hostname#id RegionalHostname#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * The region key. See [the full region list](https://developers.cloudflare.com/data-localization/regional-services/get-started/).
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.6.0/docs/resources/regional_hostname#region_key RegionalHostname#region_key}
    */
    readonly regionKey: string;
    /**
    * The zone identifier to target for the resource.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.6.0/docs/resources/regional_hostname#zone_id RegionalHostname#zone_id}
    */
    readonly zoneId: string;
    /**
    * timeouts block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.6.0/docs/resources/regional_hostname#timeouts RegionalHostname#timeouts}
    */
    readonly timeouts?: RegionalHostnameTimeouts;
}
export interface RegionalHostnameTimeouts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.6.0/docs/resources/regional_hostname#create RegionalHostname#create}
    */
    readonly create?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.6.0/docs/resources/regional_hostname#update RegionalHostname#update}
    */
    readonly update?: string;
}
export declare function regionalHostnameTimeoutsToTerraform(struct?: RegionalHostnameTimeouts | cdktf.IResolvable): any;
export declare class RegionalHostnameTimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): RegionalHostnameTimeouts | cdktf.IResolvable | undefined;
    set internalValue(value: RegionalHostnameTimeouts | cdktf.IResolvable | undefined);
    private _create?;
    get create(): string;
    set create(value: string);
    resetCreate(): void;
    get createInput(): string | undefined;
    private _update?;
    get update(): string;
    set update(value: string);
    resetUpdate(): void;
    get updateInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.6.0/docs/resources/regional_hostname cloudflare_regional_hostname}
*/
export declare class RegionalHostname extends cdktf.TerraformResource {
    static readonly tfResourceType = "cloudflare_regional_hostname";
    /**
    * Create a new {@link https://registry.terraform.io/providers/cloudflare/cloudflare/4.6.0/docs/resources/regional_hostname cloudflare_regional_hostname} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options RegionalHostnameConfig
    */
    constructor(scope: Construct, id: string, config: RegionalHostnameConfig);
    get createdOn(): string;
    private _hostname?;
    get hostname(): string;
    set hostname(value: string);
    get hostnameInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _regionKey?;
    get regionKey(): string;
    set regionKey(value: string);
    get regionKeyInput(): string | undefined;
    private _zoneId?;
    get zoneId(): string;
    set zoneId(value: string);
    get zoneIdInput(): string | undefined;
    private _timeouts;
    get timeouts(): RegionalHostnameTimeoutsOutputReference;
    putTimeouts(value: RegionalHostnameTimeouts): void;
    resetTimeouts(): void;
    get timeoutsInput(): cdktf.IResolvable | RegionalHostnameTimeouts | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
